/* $Id: ASTBinaryOperator.java,v 1.3 2006/03/25 22:02:22 gsson Exp $ */

/*
 * Copyright (c) 2006 Henrik Gustafsson <henrik.gustafsson@fnord.se>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

package se.fnord.ecalc.parser;

import java.util.ArrayList;
import java.util.List;

public class ASTBinaryOperator extends SimpleNode {
	public final static int ADDITION = 0;
	public final static int SUBTRACTION = 1;
	
	public final static int MULTIPLICATION = 2;
	public final static int DIVISION = 3;
	public final static int MODULUS = 4;
	
	public final static int POWER = 5;

	public static final int SHR = 6;
	public static final int SHL = 7;

	public static final int OR = 8;
	public static final int AND = 9;

	public List operators = new ArrayList(2);

	public void addOperator(int op) {
		operators.add(new Integer(op));
	}

	public ASTBinaryOperator(int id) {
		super(id);
	}

	public ASTBinaryOperator(ExpressionParser p, int id) {
		super(p, id);
	}

	/** Accept the visitor. * */
	public IValue accept(ExpressionParserVisitor visitor, ExpressionContext data)
			throws ExpressionException {
		return visitor.visit(this, data);
	}
}
